"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ora = require("ora");
var instance = ora();
var enabled = true;
var lastMsg = null;
var dummySpinner = {
    start: function () { },
    log: function () { },
    succeed: function () { },
    fail: function () { },
    info: function () { },
    warn: function () { }
};
var spinner = {
    start: function (msg) {
        instance.start(msg);
        lastMsg = msg;
    },
    log: function (msg) {
        instance.text = msg;
        lastMsg = msg;
    },
    // it persists the message if defined
    succeed: function (msg) {
        if (msg) {
            instance.succeed(msg);
        }
    },
    fail: function (msg) {
        instance.fail(msg);
    },
    // it persists the message
    info: function (msg) {
        instance.info(msg);
        this.start(lastMsg);
    },
    // it persists the message
    warn: function (msg) {
        instance.warn(msg);
        this.start(lastMsg);
    }
};
function disableSpinner() {
    enabled = false;
}
exports.disableSpinner = disableSpinner;
function getSpinner() {
    if (enabled) {
        return spinner;
    }
    return dummySpinner;
}
exports.getSpinner = getSpinner;
//# sourceMappingURL=spinner.js.map